#include <iostream>
#include <bits/stdc++.h>
#include <algorithm>
using namespace std;

bool f[4];

int main()
{
    f[0]=true;
    f[1]=true;
    f[2]=true;
    f[3]=true;
    f[4]=true;
    int t;
    cin>>t;
    for(int i=0;i<t;i++)
    {
        int n,m;
        cin>>n>>m;
        long long a,b;
        cin>>a>>b;
        long long y;
        long long z;
        long long p;
        long long gcd=abs(a-b);
        for(int l=2;l<n;l++)
        {

            cin>>y;
            gcd=__gcd(gcd,abs(a-y));

        }
        for(int k=0;k<m;k++)
        {


            cin>>z;
            p=a-z;
            if(abs(a-z)%gcd==0)
            {
                f[i]=false;
            }

        }


    }
    for(int i = 0; i<t; i++)
    {
        if(f[i]) cout<<"1"<<endl;
        else cout<<"0"<<endl;
    }
    return 0;
}